from Products.CMFCore.utils import getToolByName


def installActionIcons(portal, out, icons=[]):
    
    """
    install given icons. icons should be a list of tuples, each tuple
    providing: (<category>, <id>, <icon url>, <title>) 
    """
    
    actionicons=getToolByName(portal, 'portal_actionicons')

    for i in icons:
        if len(i) == 4:
            try:
                actionicons.getActionIcon(i[0], i[1])
                actionicons.updateActionIcon(i[0], i[1], i[2], i[3])
            except:
                actionicons.addActionIcon(i[0], i[1], i[2], i[3])

