from Products.CMFCore.utils import getToolByName


def installConfiglets(self, out, configlets):

    """
    Install a configlet for the plone site. configlets parameter should be a 
    list of hashes.
    """

    print >> out, 'Installing configlet...'

    ctool = getToolByName(self, 'portal_controlpanel')

    for c in configlets:
        print >> out, "-> installing configlet %s" % c['name']
        ctool.unregisterConfiglet(c['id'])
        ctool.registerConfiglet(**c)

    print >> out, "done."
