from Products.CMFCore.utils import getToolByName


def installFactory(portal, out, types=[]):

    """
    Configure our types to use the portal factory. This means that they
    are 'cancellable'.
    """

    # enable portal_factory for given types
    print >> out, 'Configuring types to use portal_factory...'
    factory_tool = getToolByName(portal,'portal_factory')
    ftypes = types + factory_tool.getFactoryTypes().keys()
    print >> out, "-> %s" % types
    factory_tool.manage_setPortalFactoryTypes(listOfTypeIds=ftypes)
    print >> out, 'done'
