from Products.CMFCore.utils import getToolByName
from Products.Archetypes.debug import deprecated


def install_roles(portal, out, roles):

    deprecated("This method is deprecated. Please use installRoles",
         level=2)

    installRoles(portal, out, roles)


def installRoles(portal, out, roles):

    """
    Install roles for the portal. Roles will be created on the portal 
    object given as argument.
    """
    
    print >> out, "Installing roles..."
    
    portal = getToolByName(portal, 'portal_url').getPortalObject()
    current_roles = portal.valid_roles()
    for new_role in roles:
        if new_role not in current_roles:
            portal._addRole(new_role)
            # needed for Plone > 2.5.*
            try: 
                prm = portal.acl_users.get('portal_role_manager', None)
                if prm is not None:
                    try:    
                        prm.addRole(new_role, new_role, "")
                    except KeyError: # role already exists
                        pass
            except AttributeError:
                pass

    print >> out, "done."
