from Products.CMFCore.utils import getToolByName


def installLanguage(portal, out, default='en', languages=()):
    
    """
    Set the languages for the portal
    """
    
    print >> out, "Installing language settings..."
    
    langtool = getToolByName(portal, 'portal_languages')
    
    # First, remove languages
    #
    langtool.removeSupportedLanguages(langtool.getSupportedLanguages())

    if langtool:
        for lang in languages:
            print >> out, "-> Adding language %s" % lang
            langtool.addSupportedLanguage(lang)
            
        print >> out, "-> Setting default language to %s" % default
        langtool.setDefaultLanguage(default)

    print >> out, "done."