def installPermissions(obj, out, permissions=()):
    
    """
    Sometimes you will want to set some permissions for your portal,
    for example to secure portal membership. In that case, this method
    is for you...
    The permissions argument should be a list of tuples, each tuple
    being:
        (permission name, acquire, roles)
    where acquire is either 0 (no acquire) or 1, and roles is a list
    of roles.
    """

    for p in permissions:
        obj.manage_permission(
                p[0], 
                p[2], 
                p[1]
         )
