from Products.PythonScripts.PythonScript import manage_addPythonScript

def installPythonScript(portal, out, root, scriptname, scriptbody, force=False):

    """
    Install a Python script somewhere in your portal.
    """
    
    print >> out, "Creating Python scripts..."
    
    if not hasattr(root.aq_inner.aq_explicit, scriptname):
      
      manage_addPythonScript(root, scriptname)    
      src = getattr(root.aq_inner.aq_explicit, scriptname)
      src.write(scriptbody)
      print >> out, "Added %s to %s" % (scriptname, root)
      
    elif hasattr(root.aq_inner.aq_explicit, scriptname) and force:
      
      src = getattr(root.aq_inner.aq_explicit, scriptname)
      src.write(scriptbody)
      print >> out, "Rewriting %s in %s" % (scriptname, root)
      
    else:
      print >> out, "Skipped adding %s to %s: already exists" % (scriptname, root)